/// footprint.cc -*- c++ -*- Hans-Peter Stoerr Tue Nov 11 2003
/// destroy random blocks in a file
/// $Id: blockdestroyer.cc,v 1.4 2003/12/29 18:06:31 stoerr Exp $

#include "options.h"

#include <stdio.h>
#include <stdlib.h>
#include <sys/time.h>

int main(int argc, char * const argv[])
{
  if (argc!=3) {
    fprintf(stderr, "%s: usage: %s destroycount filename\n", argv[0], argv[0]);
    abort();
  }

  struct timeval tv; gettimeofday(&tv,NULL);
  srandom(tv.tv_sec-tv.tv_usec);

  int destroycount=atol(argv[1]);
  int i;
  FILE* file=fopen(argv[2],"rb+");
  if (NULL == file) { perror(argv[2]); abort(); }
  fseek(file, 0, SEEK_END);
  long fsize=ftell(file);
  long fblocks=fsize/blklen;
  if ( fblocks*blklen < fsize ) ++fblocks;
  bool *destroy = new bool[fblocks]; // tells whether block no. i will be destroyed
  for (i=0; i<fblocks; ++i) destroy[i]=false;
  while ( destroycount > 0 ) {
    int rblk = random()%fblocks;
    if (!destroy[rblk]) {
      destroy[rblk]=true;
      --destroycount;
    }
  }
  char buf[blklen]; for(int i=0; i<blklen; ++i) buf[i]='e';
  for (i=0; i<fblocks; ++i) if (destroy[i]) {
    // std::cout << "destroying: " << i << "\n";
    fseek(file, i*blklen, SEEK_SET);
    if ( fblocks-1 == i ) {
      int rest = fsize-i*blklen; 
      if ( 0 != rest - fwrite(buf, sizeof(char), rest, file) ) {
        perror(argv[2]); abort();
      }
    } else {
      if ( 1 != fwrite(buf, sizeof(buf), 1, file) ) {
        perror(argv[2]); abort();
      }
    }
  }
  return 0;
}
