/* options.h -*- c++ -*- Hans-Peter Stoerr Mon Oct 27 2003 */
/* general parameters for the coding / decoding */
/// $Id: options.h,v 1.6 2003/12/30 11:01:11 stoerr Exp $

#ifndef _OPTIONS_H
#define _OPTIONS_H

#include <iostream>
#include <assert.h>
#define P(X) do { if (verbose>0) { std::cerr << #X"=" << X << std::endl; std::cerr.flush(); } } while(0)

extern bool protectmode; ///< true if protection mode, false if correction mode.
extern char* progname; ///< name of the program, as it was called.

extern char* protectedfname;     ///< the filename that is protected
extern char* eccfname;          ///< the filename that contains protection info
extern char* correctedfname;     ///< when correcting, the file where the
/// corrected protectedfile is written

const  int blklen=2048;          ///< size of one block. (not hyberblock.) 2048 bytes for CDs.
extern int hblen;               ///< number of blocks put into one hyperblock
extern const int hbcorr;        ///< number of blocks of error protection info
                                ///< for one hyperblock

extern int verbose;             ///< verbosity level
                                
/// read and interpret options and set above parameters
void readoptions(int argc, char * const argv[]);

#endif
